/*
 * 仓库SN激活统计
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class StoreSnActivateSummaryController : BaseController
    {
        public StoreSnActivateSummaryController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 仓库SN激活统计列表

        /// <summary>
        /// 根据条件查询仓库SN激活统计列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(StoreSnActivateSummary data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询仓库SN激活统计列表

        /// <summary>
        /// 仓库SN激活统计列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(StoreSnActivateSummary data, string StoreIdStoreNo, string StoreIdStoreName, string AgentStoreIdStoreNo, string AgentStoreIdStoreName, string BrandIdSelect, string CreateDateData, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();


            string condition = " and Status>-1";
            //仓库编号
            if (!string.IsNullOrEmpty(StoreIdStoreNo))
            {
                condition += " and StoreId in (select StoreId from StoreForCode where Code='" + StoreIdStoreNo + "')";
            }
            //仓库名称
            if (!string.IsNullOrEmpty(StoreIdStoreName))
            {
                condition += " and StoreId in (select StoreId from StoreForName where Name='" + StoreIdStoreName + "')";
            }
            //代理分仓仓库编号
            if (!string.IsNullOrEmpty(AgentStoreIdStoreNo))
            {
                condition += " and AgentStoreId in (select AgentStoreId from StoreForCode where Code='" + AgentStoreIdStoreNo + "')";
            }
            //代理分仓仓库名称
            if (!string.IsNullOrEmpty(AgentStoreIdStoreName))
            {
                condition += " and AgentStoreId in (select AgentStoreId from StoreForName where Name='" + AgentStoreIdStoreName + "')";
            }
            //产品类型
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and CreateDate>='" + start + " 00:00:00' and CreateDate<='" + end + " 23:59:59'";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("StoreSnActivateSummary", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //仓库
                int StoreId = int.Parse(function.CheckInt(dic["StoreId"].ToString()));
                StoreHouse storeid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == StoreId) ?? new StoreHouse();
                dic["StoreIdStoreNo"] = storeid_StoreHouse.StoreNo;
                dic["StoreIdStoreName"] = storeid_StoreHouse.StoreName;
                dic.Remove("StoreId");
                //代理分仓
                int AgentStoreId = int.Parse(function.CheckInt(dic["AgentStoreId"].ToString()));
                StoreHouse agentstoreid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == AgentStoreId) ?? new StoreHouse();
                dic["AgentStoreIdStoreNo"] = agentstoreid_StoreHouse.StoreNo;
                dic["AgentStoreIdStoreName"] = agentstoreid_StoreHouse.StoreName;
                dic.Remove("AgentStoreId");
                //产品类型
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));

            }            
            Dictionary<string, object> other = new Dictionary<string, object>();
            other.Add("ActCount", 0);
            other.Add("RejectActCount", 0);
            other.Add("PutActCount", 0);
            other.Add("EffectActCount", 0);
            other.Add("ApplyCount", 0);
            obj.Add("other", other);
            return Json(obj);
        }

        #endregion

        #region 增加仓库SN激活统计

        /// <summary>
        /// 增加或修改仓库SN激活统计信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加仓库SN激活统计

        /// <summary>
        /// 增加或修改仓库SN激活统计信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(StoreSnActivateSummary data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("StoreSnActivateSummary", Fields, 0);
            AddSysLog(data.Id.ToString(), "StoreSnActivateSummary", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改仓库SN激活统计

        /// <summary>
        /// 增加或修改仓库SN激活统计信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            StoreSnActivateSummary editData = db.StoreSnActivateSummary.FirstOrDefault(m => m.Id == Id) ?? new StoreSnActivateSummary();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改仓库SN激活统计

        /// <summary>
        /// 增加或修改仓库SN激活统计信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(StoreSnActivateSummary data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("StoreSnActivateSummary", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "StoreSnActivateSummary", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除仓库SN激活统计信息

        /// <summary>
        /// 删除仓库SN激活统计信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "StoreSnActivateSummary", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("StoreSnActivateSummary", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "StoreSnActivateSummary", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("StoreSnActivateSummary", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "StoreSnActivateSummary", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("StoreSnActivateSummary", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("StoreSnActivateSummary", Sort, Id);

            AddSysLog(Id.ToString(), "StoreSnActivateSummary", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.StoreSnActivateSummary.Add(new StoreSnActivateSummary()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "StoreSnActivateSummary", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(StoreSnActivateSummary data, string StoreIdStoreNo, string StoreIdStoreName, string AgentStoreIdStoreNo, string AgentStoreIdStoreName, string BrandIdSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //仓库编号
            if (!string.IsNullOrEmpty(StoreIdStoreNo))
            {
                condition += " and StoreId in (select StoreId from StoreForCode where Code='" + StoreIdStoreNo + "')";
            }
            //仓库名称
            if (!string.IsNullOrEmpty(StoreIdStoreName))
            {
                condition += " and StoreId in (select StoreId from StoreForName where Name='" + StoreIdStoreName + "')";
            }
            //代理分仓仓库编号
            if (!string.IsNullOrEmpty(AgentStoreIdStoreNo))
            {
                condition += " and AgentStoreId in (select AgentStoreId from StoreForCode where Code='" + AgentStoreIdStoreNo + "')";
            }
            //代理分仓仓库名称
            if (!string.IsNullOrEmpty(AgentStoreIdStoreName))
            {
                condition += " and AgentStoreId in (select AgentStoreId from StoreForName where Name='" + AgentStoreIdStoreName + "')";
            }
            //产品类型
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("StoreSnActivateSummary", Fields, "Id desc", "0", 1, 20000, condition, "TradeDate,TradeMonth,StoreId,AgentStoreId,BrandId,ActivateNum,RejectActNum,TransferActNum,EffectActNum,UserApplyNum,Remark", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //仓库
                int StoreId = int.Parse(function.CheckInt(dic["StoreId"].ToString()));
                StoreHouse storeid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == StoreId) ?? new StoreHouse();
                dic["StoreIdStoreNo"] = storeid_StoreHouse.StoreNo;
                dic["StoreIdStoreName"] = storeid_StoreHouse.StoreName;
                dic.Remove("StoreId");
                //代理分仓
                int AgentStoreId = int.Parse(function.CheckInt(dic["AgentStoreId"].ToString()));
                StoreHouse agentstoreid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == AgentStoreId) ?? new StoreHouse();
                dic["AgentStoreIdStoreNo"] = agentstoreid_StoreHouse.StoreNo;
                dic["AgentStoreIdStoreName"] = agentstoreid_StoreHouse.StoreName;
                dic.Remove("AgentStoreId");
                //产品类型
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("TradeDate", "交易日");
            ReturnFields.Add("TradeMonth", "交易月");
            ReturnFields.Add("StoreIdStoreNo", "仓库编号");
            ReturnFields.Add("StoreIdStoreName", "仓库名称");
            ReturnFields.Add("AgentStoreIdStoreNo", "代理分仓仓库编号");
            ReturnFields.Add("AgentStoreIdStoreName", "代理分仓仓库名称");
            ReturnFields.Add("BrandId", "产品类型");
            ReturnFields.Add("ActivateNum", "激活数量");
            ReturnFields.Add("RejectActNum", "互斥激活数量");
            ReturnFields.Add("TransferActNum", "划拨激活数量(循环机划拨激活数)");
            ReturnFields.Add("EffectActNum", "有效激活数量");
            ReturnFields.Add("UserApplyNum", "创客申请数量");
            ReturnFields.Add("Remark", "备注");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "StoreSnActivateSummary", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
